#INCLUDE "dcdialog.CH"
#INCLUDE "XCodeJock.CH"
#INCLUDE "CommandBars.CH"
#INCLUDE "Definitions.CH"
#INCLUDE "fileio.CH"
#INCLUDE "dcbitmap.CH"

#DEFINE TRUE  .t.
#DEFINE FALSE .f.


FUNCTION Main()

LOCAL Getlist[0], Getoptions, oCommandBars, oImageManager, oStatic, oTabToolBar, ;
      nTheme, oDlg, oBrowse, aDir := Directory()

nTheme := xtpThemeWhidbey

CJCOMMANDBARS oCommandBars ;
       VISUALTHEME nTheme ;
       RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
       SCALEMODE xtpScalePixel

@0,0 DCSAY '' OBJECT oStatic COLOR GRA_CLR_RED, GRA_CLR_WHITE ;
      SIZE 300, 300 FONT '16.Arial Bold' SAYWORDBREAK ;
      SAYOPTIONS XBPSTATIC_TEXT_VCENTER + XBPSTATIC_TEXT_CENTER + XBPSTATIC_TEXT_WORDBREAK ;
      EVAL {|o|o:setCaption('Tabbed Toolbar Test Program')}

@ 50,0 DCBROWSE oBrowse DATA aDir ;
      PARENT oStatic ;
      FONT '10.Lucida Console' ;
      SIZE DCGUI_PARENTWIDTH, DCGUI_PARENTHEIGHT-50 PIXEL ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCBROWSECOL ELEMENT 1 HEADER 'File Name' WIDTH 250 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER 'File Size' WIDTH 100 PARENT oBrowse
DCBROWSECOL ELEMENT 3 HEADER 'File Date' WIDTH 100 PARENT oBrowse
DCBROWSECOL ELEMENT 4 HEADER 'File Time' WIDTH 100 PARENT oBrowse

DCGETOPTIONS RESIZE PIXEL ;
   CLOSEQUERY MSG {||SaveState(oCommandBars),.t.} ;
   COLOR GRA_CLR_WHITE ;
   HIDE

DCREAD GUI TITLE 'CodeJock Command Bar w/TabbedToolBar' OPTIONS GetOptions ;
     EVAL {|o|oDlg := o, ;
             BuildTabbedToolBar( oCommandBars, @oTabToolBar, oStatic, oDlg, @nTheme, GetList ), ;
             nil, ;
             o:show()}

RETURN nil

* -----------

PROC appsys ; RETURN

* -----------

STATIC FUNCTION BuildTabbedToolbar( oCommandBars, oTabToolBar, oStatic, oDlg, nTheme, GetList )

LOCAL oTab, oControl, iCount, cIconPath, oMenuBar, oViewMenuToolbars
LOCAL oFileMenu, oEditMenu, oViewMenu, oStatusBar, oMessageBar
LOCAL oHelpMenu, oThemeMenu, oStyleMenu, aIconArray[5], oOptions, bOption
LOCAL oRibbonBar, oControlFile

// oCommandBars:enableOffice2007Frame(.t.)
// oCommandBars:enableOffice2007FrameHandle(oDlg:getHWnd())


cIconPath := '.\icons\'

oOptions := oCommandBars:getProperty("options")

bOption := {|nId,oControl|SetOption(nId,oControl,oCommandBars,oTabToolBar,@nTheme), ;
                          oCommandBars:recalcLayout(), ;
                          oCommandBars:ResizeDrawingArea( oDlg, .t., GetList )}

CJAddRibbonBar oRibbonBar NAME 'Ribbonbar1' PARENT oCommandBars ;
   ENABLEDOCKING xtpFlagStretched ;
   SHOWQUICKACCESS TRUE

  CJAddSystemButton oControlFile ICONID 1 CAPTION 'Misc' PARENT oRibbonBar

    CJMenuItem oControl PARENT oControlFile CAPTION 'e&Xit' ID 30 ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

CJTabbedToolBar oTabToolBar NAME 'Standard Tabbed Toolbar' ;
   MINWIDTH 400 ICONSIZE 20,20 PARENT oCommandBars

CJTabbedToolBarCategory oTab CATEGORY "Standard" IMAGE ID_TAB_ICON PARENT oTabToolBar

CJTabbedToolBarCategory oTab CATEGORY "Advanced" IMAGE ID_TAB_ICON PARENT oTabToolBar

CJTabbedToolBarCategory oTab CATEGORY "Other" IMAGE ID_TAB_ICON PARENT oTabToolBar

CJTabbedToolBarCategory oTab CATEGORY "User Tools" IMAGE ID_TAB_ICON PARENT oTabToolBar

//Add buttons to the "Standard" category
FOR iCount := ID_STANDARD_1 TO ID_STANDARD_19

  CJAddToolButton oControl ;
     ID iCount ;
     PARENT oTabToolBar ;
     CATEGORY "Standard" ;
     TOOLTIP 'Standard Button ' + Alltrim(Str(iCount)) ;
     CAPTION "Standard " + Alltrim(Str(iCount)) ;
     ACTION ActionBlock(iCount,oCommandBars,oDlg,oStatic) ;
     ICON cIconPath + "standard_" + Alltrim(Str(iCount - 500)) + ".ico" ;
     WHEN WhenBlock(iCount,oCommandBars) ;
     HIDE HideBlock(iCount,oCommandBars)

NEXT

// Add buttons to the "Advanced" category
FOR iCount := ID_ADVANCED_1 TO ID_ADVANCED_13

  CJAddToolButton oControl ;
     ID iCount ;
     PARENT oTabToolBar ;
     CATEGORY "Advanced" ;
     TOOLTIP 'Advanced Button ' + Alltrim(Str(iCount)) ;
     CAPTION "Advanced " + Alltrim(Str(iCount)) ;
     ACTION ActionBlock(iCount,oCommandBars,oDlg,oStatic) ;
     ICON cIconPath + "advanced_" + Alltrim(Str(iCount - 600)) + ".ico"

NEXT

//Add buttons to the "Other" category
FOR iCount := ID_OTHER_1 TO ID_OTHER_14

  CJAddToolButton oControl ;
     ID iCount ;
     PARENT oTabToolBar ;
     CATEGORY "Other" ;
     TOOLTIP 'Other Button ' + Alltrim(Str(iCount)) ;
     CAPTION "Other " + Alltrim(Str(iCount)) ;
     ACTION ActionBlock(iCount,oCommandBars,oDlg,oStatic) ;
     ICON cIconPath + "other_" + Alltrim(Str(iCount - 700)) + ".ico"

NEXT

//Add buttons to the "User Tools" category
FOR iCount := ID_USER_TOOLS_1 TO ID_USER_TOOLS_5

  CJAddToolButton oControl ;
     ID iCount ;
     PARENT oTabToolBar ;
     CATEGORY "User Tools" ;
     TOOLTIP 'User Tools Button ' + Alltrim(Str(iCount)) ;
     CAPTION "User " + Alltrim(Str(iCount)) ;
     ACTION ActionBlock(iCount,oCommandBars,oDlg,oStatic)

NEXT

//Change the appearce of the tab buttons
// oTabToolBar:TabPaintManager:Appearance := xtpTabAppearanceFlat

//Adds all the controls to the appropriate Categories inside the Tabbed Toolbar
oTabToolBar:UpdateTabs()

CJMENUBAR oMenuBar NAME 'Menu' PARENT oCommandBars

CJSUBMENU oFileMenu PARENT oMenuBar CAPTION '&File'

  CJMENUITEM oControl PARENT oFileMenu CAPTION '&New' ID ID_FILE_NEW ;
    TOOLTIP 'Select this menu item to create a new file' ;
    DESCRIPTION 'Create a new File' ;
    ICON BITMAP_CALCULATOR_M ;
    STYLE xtpButtonCaptionAndDescription ;
    ACTION {||oStatic:setCaption('File->New File')} ;
    HOTKEY FCONTROL, Asc("N")

  CJMENUITEM oControl PARENT oFileMenu CAPTION '&Close' ID ID_FILE_CLOSE ;
    DESCRIPTION 'Close the currently opened File' ;
    ICON BITMAP_HELP_M ;
    STYLE xtpButtonCaptionAndDescription ;
    HOTKEY FCONTROL, Asc("C") ;
    ACTION {||oStatic:setCaption('File->Close File')}

  CJMENUITEM oControl PARENT oFileMenu CAPTION '&Save' ID ID_FILE_SAVE ;
    DESCRIPTION 'Save this file to disk' ;
    ICON BITMAP_RTF_M ;
    STYLE xtpButtonCaptionAndDescription ;
    HOTKEY FCONTROL, Asc("S") ;
    ACTION {||oStatic:setCaption('File->Save file to Disk')}

  CJMENUITEM oControl PARENT oFileMenu CAPTION '&Print' ID ID_FILE_PRINT ;
    ICON BITMAP_DESIGN_M ;
    BEGINGROUP TRUE ;
    HOTKEY FCONTROL, Asc("P") ;
    ACTION {||oStatic:setCaption('File->Print')}

  CJMENUITEM oControl PARENT oFileMenu CAPTION 'Print Set&up...' ID ID_FILE_PRINT_SETUP ;
    ICON BITMAP_HEX_M ;
    BEGINGROUP TRUE ;
    HOTKEY FCONTROL, Asc("U") ;
    ACTION {||oStatic:setCaption('File->Print Setup')}

CJSUBMENU oEditMenu PARENT oMenuBar CAPTION '&Edit'

  CJMENUITEM oControl PARENT oEditMenu CAPTION '&Undo' ID ID_EDIT_UNDO ;
    ACTION {||oStatic:setCaption('Edit->Undo')}

  CJMENUITEM oControl PARENT oEditMenu CAPTION 'Cu&t' ID ID_EDIT_CUT ;
    ACTION {||oStatic:setCaption('Edit->Cut')} ;
    HOTKEY FCONTROL, Asc("X") ;

  CJMENUITEM oControl PARENT oEditMenu CAPTION '&Copy' ID ID_EDIT_COPY ;
    ACTION {||oStatic:setCaption('Edit->Copy')} BEGINGROUP TRUE ;
    HOTKEY FCONTROL, Asc("C") ;

  CJMENUITEM oControl PARENT oEditMenu CAPTION '&Paste' ID ID_EDIT_PASTE ;
    ACTION {||oStatic:setCaption('Edit->Paste')} ;
    HOTKEY FCONTROL, Asc("V") ;

CJSUBMENU oViewMenu PARENT oMenuBar CAPTION '&View'

  CJSUBMENU oViewMenuToolbars PARENT oViewMenu:commandBar CAPTION '&Toolbars'

    CJMENUITEM oControl PARENT oViewMenuToolbars CAPTION '&Toolbar List' ID XTP_ID_TOOLBARLIST

  CJMENUITEM oControl PARENT oViewMenu CAPTION 'Status Bar' ID ID_VIEW_STATUSBAR ;
    ACTION {||oStatic:setCaption('View->Status Bar')}

  CJMENUITEM oControl PARENT oViewMenu CAPTION '&Properties' ID ID_VIEW_PROPERTIES ;
    ACTION {||oStatic:setCaption('View->Properties')}

CJSUBMENU oThemeMenu PARENT oMenuBar CAPTION '&Theme'

  CJMENUITEM oControl PARENT oThemeMenu CAPTION 'Office 2000' ID ID_THEME_OFFICE2000 ACTION bOption
  CJMENUITEM oControl PARENT oThemeMenu CAPTION 'Office XP' ID ID_THEME_OFFICEXP ACTION bOption
  CJMENUITEM oControl PARENT oThemeMenu CAPTION 'Office 2003' ID ID_THEME_OFFICE2003 ACTION bOption
  CJMENUITEM oControl PARENT oThemeMenu CAPTION 'Native Win XP' ID ID_THEME_NATIVEWINXP ACTION bOption
  CJMENUITEM oControl PARENT oThemeMenu CAPTION 'Whidbey' ID ID_THEME_WHIDBEY ACTION bOption
  CJMENUITEM oControl PARENT oThemeMenu CAPTION 'Office 2007' ID ID_THEME_OFFICE2007 ACTION bOption
  CJMENUITEM oControl PARENT oThemeMenu CAPTION 'Ribbon' ID ID_THEME_RIBBON ACTION bOption
  CJMENUITEM oControl PARENT oThemeMenu CAPTION 'Visual Studio 2008' ID ID_THEME_VISUALSTUDIO2008 ACTION bOption

CJSUBMENU oStyleMenu PARENT oMenuBar CAPTION '&Style'

  CJMENUITEM oControl PARENT oStyleMenu CAPTION 'Automatic' ID ID_BUTTONSTYLE_AUTOMATIC ACTION bOption
  CJMENUITEM oControl PARENT oStyleMenu CAPTION 'Caption' ID ID_BUTTONSTYLE_CAPTION ACTION bOption
  CJMENUITEM oControl PARENT oStyleMenu CAPTION 'Icon' ID ID_BUTTONSTYLE_ICON ACTION bOption
  CJMENUITEM oControl PARENT oStyleMenu CAPTION 'Icon and Caption' ID ID_BUTTONSTYLE_ICONANDCAPTION ACTION bOption
  CJMENUITEM oControl PARENT oStyleMenu CAPTION 'Icon and Caption Below' ID ID_BUTTONSTYLE_ICONANDCAPTIONBELOW ACTION bOption
  CJMENUITEM oControl PARENT oStyleMenu CAPTION 'Caption and Description' ID ID_BUTTONSTYLE_CAPTIONANDDESCRIPTION ACTION bOption

CJSUBMENU oHelpMenu PARENT oMenuBar CAPTION '&Help'

  CJMENUITEM oControl PARENT oHelpMenu CAPTION '&About' ID ID_HELP_ABOUT ;
    ACTION {||oStatic:setCaption('Help->About')}

CJLoadIcon cIconPath + "App.ico" ID ID_TAB_ICON STATE xtpImageNormal PARENT oCommandBars:icons

aIconArray[1] := ID_USER_TOOLS_1
aIconArray[2] := ID_USER_TOOLS_2
aIconArray[3] := ID_USER_TOOLS_3
aIconArray[4] := ID_USER_TOOLS_4
aIconArray[5] := ID_USER_TOOLS_5

CJLoadBitmap cIconPath + "usertools.bmp" ID aIconArray STATE xtpImageNormal PARENT oCommandBars:icons
CJLoadIcon cIconPath + "app.ico" ID 1 STATE xtpImageNormal PARENT oCommandBars:icons

oOptions:UseDisabledIcons := .T.

oStatusBar := oCommandBars:StatusBar

oStatusBar:Visible := .T.
oMessageBar := oStatusBar:AddPane(0)
oMessageBar:setProperty('font',CJ_Font('10.Lucida Console Bold'))
oStatusBar:AddPane(ID_INDICATOR_CAPS)
oStatusBar:AddPane(ID_INDICATOR_NUM)
oStatusBar:AddPane(ID_INDICATOR_SCRL)

oCommandBars:EnableCustomization(.T.)

oOptions:updatePeriod := 500
oCommandBars:update := {||oCommandBars:ResizeDrawingArea(oDlg,.t.,GetList)}
RestoreState(oCommandBars)
oCommandBars:ResizeDrawingArea(oDlg,.t.,GetList)

RETURN nil

* ---------------

STATIC FUNCTION ActionBlock( nId, oCommandBars, oDlg, oStatic )

RETURN {||oStatic:setCaption('You clicked on ' + Alltrim(Str(nId))), ;
          oCommandBars:resizeDrawingArea(oDlg)}

* ---------------

STATIC FUNCTION WhenBlock( i, oCommandBars )

RETURN {||IIF(i%2==0,.t.,.f.)} // disable every 2nd button

* ---------------

STATIC FUNCTION HideBlock( i, oCommandBars )

RETURN {||IIF(i%4==0,.t.,.f.)} // hide every 4th button

* ---------------

STATIC FUNCTION SaveState( oCommandBars )

oCommandBars:SaveCommandBars( 'XCodeJock', 'Tabbed ToolBar Demo','Layout')

RETURN nil

* ---------------

STATIC FUNCTION RestoreState( oCommandBars )

oCommandBars:LoadCommandBars( 'XCodeJock', 'Tabbed ToolBar Demo','Layout')

RETURN nil

* ------------

FUNCTION SetOption( nId, oControl, oCommandBars, oTabToolBar, nTheme )

IF nId == ID_THEME_OFFICE2000
  nTheme := oCommandBars:visualTheme := xtpThemeOffice2000
ELSEIF nId == ID_THEME_OFFICEXP
  nTheme := oCommandBars:visualTheme := xtpThemeOfficeXP
ELSEIF nId == ID_THEME_OFFICE2003
  nTheme := oCommandBars:visualTheme := xtpThemeOffice2003
ELSEIF nId == ID_THEME_NATIVEWINXP
  nTheme := oCommandBars:visualTheme := xtpThemeNativeWinXP
ELSEIF nId == ID_THEME_WHIDBEY
  nTheme := oCommandBars:visualTheme := xtpThemeWhidbey
ELSEIF nId == ID_THEME_OFFICE2007
  nTheme := oCommandBars:visualTheme := xtpThemeOffice2007
ELSEIF nId == ID_THEME_RIBBON
  nTheme := oCommandBars:visualTheme := xtpThemeRibbon
ELSEIF nId == ID_THEME_VISUALSTUDIO2008
  nTheme := oCommandBars:visualTheme := xtpThemeVisualStudio2008
ELSEIF nId == ID_BUTTONSTYLE_CAPTION
  oTabToolBar:defaultButtonStyle := xtpButtonCaption
  oCommandBars:visualTheme := nTheme
ELSEIF nId == ID_BUTTONSTYLE_ICON
  oTabToolBar:defaultButtonStyle := xtpButtonIcon
  oCommandBars:visualTheme := nTheme
ELSEIF nId == ID_BUTTONSTYLE_ICONANDCAPTION
  oTabToolBar:defaultButtonStyle := xtpButtonIconAndCaption
  oCommandBars:visualTheme := nTheme
ELSEIF nId == ID_BUTTONSTYLE_ICONANDCAPTIONBELOW
  oTabToolBar:defaultButtonStyle := xtpButtonIconAndCaptionBelow
  oCommandBars:visualTheme := nTheme
ELSEIF nId == ID_BUTTONSTYLE_CAPTIONANDDESCRIPTION
  oTabToolBar:defaultButtonStyle := xtpButtonCaptionAndDescription
  oCommandBars:visualTheme := nTheme
ELSEIF nId == ID_BUTTONSTYLE_AUTOMATIC
  oTabToolBar:defaultButtonStyle := xtpButtonAutomatic
  oCommandBars:visualTheme := nTheme
ENDIF

RETURN nil


